#-*- coding: utf-8 -*-
"""
$Id$
"""
from zope.interface import implements
from zsqlmap.interfaces import IConditionExpr, IConditionManager


class CondExpr:
    implements(IConditionExpr)
    def __init__(self, sql, params):
        self.sql = sql
        self.params = params

class ConditionManager:
    implements(IConditionManager)

    def AND(self, *condexprs):
        sqls = []
        params = [] 
        for cond in condexprs:
            sqls.append(cond.sql)
            params += cond.params       
        return CondExpr(' AND '.join(sqls), params )
            
    def OR(self, *condexprs):
        sqls = []
        params = [] 
        for cond in condexprs:
            sqls.append(cond.sql)
            params += cond.params       
        return CondExpr(' OR '.join(sqls), params )

    def NOT(self, condexpr):
        return CondExpr( ' NOT(%s)' % condexpr.sql, condexpr.params) 
        
    def EQ(self, name, value):
        " == "
        return CondExpr('%s = %s' % (name,'%s'), (value,))
        
    def NE(self, name, value):
        "!="        
        return CondExpr('%s <> %s' % (name,'%s'), (value,))

    def LT(self, name, value):
        "<"
        return CondExpr('%s < %s' % (name,'%s'), (value,))
        
    def LE(self, name, value):
        "<="
        return CondExpr('%s <= %s' % (name,'%s'), (value,))
        
    def GT(self, name, value):
        ">"        
        return CondExpr('%s > %s' % (name,'%s'), (value,))
        
    def GE(self, name, value):
        " >="
        return CondExpr('%s >= %s' % (name,'%s'), (value,))
        
    def LIKE(self, name, value):
        return CondExpr('%s LIKE %s' % (name,'%s'), (value,))

    def ILIKE(self, name, value):
        return CondExpr('UPPER(%s) LIKE %s' % (name,'%s'), (value.upper(),))

    def BETWEEN(self, name, r1, r2):
        return CondExpr('%s BETWEEN %s AND %s' % (name,'%s','%s'), (r1,r2))
        
    def ISNULL(self, name):
        return CondExpr('%s ISNULL' % name, ())
