#-*- coding:utf-8 -*-
"""  ORM Manager for gadfly (only for test purpose)
$Id$
"""

from zsqlmap import ORMManager
from zsqlmap import interfaces
from zsqlmap.cond import CondExpr
import transaction

class ORMGadfly(ORMManager):

    def __init__(self, da_name):
        super(ORMGadfly, self).__init__(da_name)

    def restyle(self, sql):
        return sql.replace('%s', '?')
        
    def _generateID(self, obj):
        sql = "SELECT count(*) FROM %s" % obj.table
        cur = self.connection.cursor()
        cur.execute(sql)
        count = cur.fetchone()[0]
        if count == 0:
            return 1

        sql = "SELECT max(id) FROM %s" % obj.table
        cur.execute(sql)
        mid = cur.fetchone()[0]
        return mid + 1
        
    def createTableSQL(self, cls):
        cols_sql = []
        for col in cls.columns:
            cols_sql.append(self._column_sql(col))

        yield "CREATE TABLE %s (id integer, %s)" % (cls.table, ','.join(cols_sql) )
        yield "CREATE unique INDEX %s_id_key ON %s(id) " % (cls.table, cls.table)
    
            
    def _column_sql(self, col):
        if interfaces.IIntCol.providedBy(col):
            return "%s integer" % col.name

        sql = "%s varchar" % col.name
        return sql

    
    def LIKE(self, name, value):
        raise NotImplementedError(" 'LIKE' not supported for gadfly")

    def ILIKE(self, name, value):
        raise NotImplementedError(" 'ILIKE' not supported for gadfly")

    def ISNULL(self, name):
        raise NotImplementedError(" 'ISNULL' not supported for gadfly")


    def NOT(self, condexpr):
        raise NotImplementedError(" 'NOT' not supported for gadfly")

