#-*- coding:utf-8 -*-
""" 
$Id$
"""
import os
import tempfile
import unittest
from doctest import DocFileSuite

from zope.app import zapi
from zope.rdb.gadflyda import GadflyAdapter, setGadflyRoot

from zsqlmap.gadfly import ORMGadfly 
from zsqlmap.tests.orm_test_base import BaseTestORM

tempdir = None

def getGadflyRoot():
    global tempdir
    tempdir = tempfile.mkdtemp('gadfly')
    setGadflyRoot(tempdir)
    
def getDA():
    getGadflyRoot()
    os.mkdir(os.path.join(tempdir, "test"))
    da = GadflyAdapter("dbi://demo;dir=test")
    return da

def getORMManager(da_name):
    orm = ORMGadfly(da_name=da_name)
    return orm


class TestGadFlyORM(BaseTestORM):
    
    def getDA(self):
        return getDA()
    
    def getORMManager(self, da_name):
        return getORMManager(da_name)

    
def test_suite():
    return unittest.TestSuite((
        unittest.makeSuite(TestGadFlyORM),
        DocFileSuite('../README.txt',
                     globs={'getDA': getDA,
                            'getORMManager':getORMManager
                            }),        

        ))

if __name__ == '__main__':
    unittest.main(defaultTest='test_suite')


