#-*- coding:utf-8 -*-
""" 
$Id$
"""
import unittest

from zope.app import zapi

from zsqlmap.tests.orm_test_base import *
from zsqlmap.mssql import ORM_MSSQL
from zsqlmap.mssql.da import MSSQLAdapter
from doctest import DocFileSuite


def getDA():
    #dsn = 'dbi://os:os@192.168.1.2:1433/zsqlmap'
    dsn = 'dbi://os:os@192.168.69.128:1433/zsqlmap'
    da = MSSQLAdapter(dsn)
    return da

def getORMManager(da_name):
    orm = ORM_MSSQL(da_name=da_name)
    return orm


class TestORM(BaseTestORM):

    def getDA(self):
        return getDA()

    def getORMManager(self, da_name):
        return getORMManager(da_name)
    
def test_suite():
    return unittest.TestSuite((
         unittest.makeSuite(TestORM),
         DocFileSuite('doc.txt',
                       globs={'getDA': getDA,
                              'getORMManager':getORMManager
                              }),
         DocFileSuite('../README.txt',
                      globs={'getDA': getDA,
                             'getORMManager':getORMManager
                             }),        
         ))

if __name__ == '__main__':
    unittest.main(defaultTest='test_suite')


