#-*- coding:utf-8 -*-
"""  Simple Zope3 Database Adapter for Postgres (psycopg2)
$Id$
"""
import psycopg2 
from zope.rdb import ZopeDatabaseAdapter, parseDSN

class PostgresAdapter(ZopeDatabaseAdapter):
    dsn2option_mapping = {'host': 'host',
                          'port': 'port',
                          'dbname': 'dbname',
                          'username': 'user',
                          'password': 'password'}

    def _connection_factory(self):    
        conn_info = parseDSN(self.dsn)
        conn_list = []
        for dsnname, optname in self.dsn2option_mapping.iteritems():
            if conn_info[dsnname]:
                conn_list.append('%s=%s' % (optname, conn_info[dsnname]))                        

        conn_str = ' '.join(conn_list)

        connection = psycopg2.connect(conn_str)
        
        return connection
    
