#-*- coding:utf-8 -*-
""" 
$Id$
"""
import unittest

from zope.app import zapi

from zsqlmap.tests.orm_test_base import BaseTestORM
from zsqlmap.postgres import ORMPostgres
from zsqlmap.postgres.da import PostgresAdapter
from doctest import DocFileSuite


def getDA():
    dsn = 'dbi://postgres:aport@localhost:5432/zsqlmap'
    da = PostgresAdapter(dsn)
    return da

def getORMManager(da_name):
    orm = ORMPostgres(da_name=da_name)
    return orm


class TestORM(BaseTestORM):

    def getDA(self):
        return getDA()

    def getORMManager(self, da_name):
        return getORMManager(da_name)






def test_suite():
    return unittest.TestSuite((
        unittest.makeSuite(TestORM),
        DocFileSuite('doc.txt',
                     globs={'getDA': getDA,
                            'getORMManager':getORMManager
                            }),
        DocFileSuite('../README.txt',
                     globs={'getDA': getDA,
                            'getORMManager':getORMManager
                            }),        
        ))

if __name__ == '__main__':
    unittest.main(defaultTest='test_suite')


